// fldSlope.h

//----------------------------------------------------------------------
//	FldSlope		$B<PLL%b%G%k(B(FldDyna $BMQ(B)
//----------------------------------------------------------------------

#if !defined(_fldSlope_h)
#define _fldSlope_h

#include <stdio.h>

#include "common.h"		// $B6&DL4D6-$NDj5A(B
#include "element.h"	// $B%/%i%9(B Element $B$NDj5A(B
#include "p_tmp.h"		// $B%F%s%W%l!<%H%/%i%9(B Receive, Send $B$NDj5A(B
#include "list.h"		// $B%/%i%9(B List $B$NDj5A(B
#include "vary.h"		// $B%/%i%9(B Vary $B$NDj5A(B
#include "fldDynaNR.h"	// $B%/%i%9(B FldDynaNR $B$NDj5A(B

typedef Vary<double> Vdary;

inline void Clf_vdary(void* obj)
{	delete ((Data<Vdary>*) obj);	}

//	$B%/%i%9(B FldSlope $B$NDj5A(B

class FldSlope : public Element {

//	$B%Q%i%a%?(B

  protected:
	size_t n_row;		// $B9T$N?t(B
	size_t n_col;		// $BNs$N?t(B
	size_t n_cell;		// $BA4%;%k$N?t(B
	
//	$B>uBVNL(B

  protected:
	List slist;		// $BB&J}N.F~NL$r5-21$9$k%j%9%H(B
					// $B%G!<%?$O?^3THV9f$N>.$5$$=g$KJB$s$G$$$k$b$N$H$9$k(B
	Data<Vdary>* p;

//	$B<u?.C<;R(B

  protected:
	void Register_receive_ports(void) {}

//	$BAw?.C<;R(B

  protected:
	void Register_send_ports(void) {}

//	$B=i4|2=4X?t!&%3%s%9%H%i%/%?!&%G%9%H%i%/%?(B

  public:
	Boolean Init(char* o_name, int o_num, size_t num_row, size_t
				 num_col, char* f_name);

	FldSlope(char* o_name, int o_num, size_t num_row, size_t num_col,
			 char* f_name);
	FldSlope(void);
	~FldSlope(void) {}

//	$B%Q%i%a%?$N@_Dj!&>uBVNL$N=i4|2=!&:G=*>uBVNL$NJ]B8(B

  protected:
	void Set_parameter(FILE*) {}
	void Set_initial_state(FILE*) {}
	void Save_terminal_state(FILE*) {}

//	$B7W;;5!G=(B

  protected:
	Boolean Initial_output(void) { return YES; }
	time_t Calculate_time_step(void) { return 1000000; }
	Boolean Can_you_calculate(void) { return Can_you_calculate0(); }
	Boolean Work(void) { return Work0(); }
	Boolean Calculate(void) { return YES; }

//	$B%/%i%9(B FldSlope $B$KFCM-$N4X?t(B

  public:
	Boolean Re_lat(size_t row, size_t col, time_t ct, double& lat);
	// $B;XDj$5$l$??^3THV9f$N%;%k$N;XDj$5$l$?7W;;;~9o$G$NB&J}N.F~NL$r(B
	// $BJV$94X?t!#(B

};

#endif	// ! _fldSlope_h
